/**
 * @author Lim Long Hei Roy
 * @Finished by Renpi Yu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
	//Example Swing program to illustrate a very simple text editor
//Need to import classes from all these packages
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
public class FullyFunctionalEditor extends JFrame {
  //Instance variables for the GUI components used.
  //Declaring the variables here allows them to be
  //used by any instance methods in the class.
  JPanel topPanel;
  JPanel leftButtonPanel;
  JPanel rightButtonPanel;
  JPanel editorPanel;
  JButton loadButton;
  JButton saveButton;
  JButton cutButton;
  JButton copyButton;
  JButton pasteButton;
  JButton runScriptButton;
  JButton codeGenerateButton;
  JButton installButton;
  JScrollPane scroller;
  JTextArea editor;
  
  private String filePath = null;
  private String fileDir = null;
  private MessageBox alert;
  
  //public File openedFile;
  //The constructor build the window using a utility
  //method and displays it.
  public FullyFunctionalEditor() {
	//Create and configure the various panels
	topPanel = new JPanel ();
	topPanel.setLayout (new BorderLayout ());
        
	editorPanel = new JPanel ();
	editorPanel.setLayout(new BorderLayout ());
	editorPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	leftButtonPanel = new JPanel ();
	rightButtonPanel = new JPanel ();
	rightButtonPanel.setBorder(BorderFactory.createEtchedBorder());
	leftButtonPanel.setBorder(BorderFactory.createEtchedBorder ());
        
	//The panel containing the buttons uses a GridLayout of 1 column
	//and 5 rows to position the buttons in a column.
	GridLayout grid = new GridLayout ();
	grid.setColumns(1);
	grid.setHgap(10);
	grid.setRows(5); //Set a small gap between the buttons
	grid.setVgap(3); //to improve the appearance
	GridLayout grid2 = new GridLayout();
	grid2.setColumns(1);
	grid2.setHgap(10);
	grid2.setRows(3);
	grid2.setVgap(3);
	leftButtonPanel.setLayout(grid);
	rightButtonPanel.setLayout(grid2);

	//Now create the buttons, giving each a listener to respond to
	//the button being clicked. The listener methods delegate to
	//private helper methods later in the class, to avoid the
	//constructor method becoming too long and unwieldy.
	loadButton = new JButton("Load");
	loadButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		loadFile();
	  }
	});
	saveButton = new JButton("Save");
	saveButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		saveFile();
	  }
	});
	cutButton = new JButton("Cut");
	cutButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		cut();
	  }
	});
	copyButton = new JButton("Copy");
	copyButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		copy();
	  }
	});
	pasteButton = new JButton("Paste");
	pasteButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		paste();
	  }
	});
	runScriptButton = new JButton("Run Script");
        runScriptButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		runScript();
	  }
	});
	codeGenerateButton = new JButton("Code Generate");
        codeGenerateButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e){ 
                //MainWindow.tArea.append("bmac " + filePath + "\n");
                MainWindow.tArea.append("Start generating C code from behavioral model...\n");
                codeGenerate();
          }
        });
	installButton = new JButton("Install");
        installButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e){ 
                //MainWindow.tArea.append("./install.spice3f5\n");
                MainWindow.tArea.append("Start installing C code...\n");
                install();
          }
        });

// ADD ACTIONLISTENER HERE FOR INSTALL PANEL
        
        leftButtonPanel.add(loadButton);
	leftButtonPanel.add(saveButton);
	leftButtonPanel.add(cutButton);
	leftButtonPanel.add(copyButton);
	leftButtonPanel.add(pasteButton);
	rightButtonPanel.add(runScriptButton);
	rightButtonPanel.add(codeGenerateButton);
	rightButtonPanel.add(installButton);
          
        //The editor component handles all text display and editing. It
	//is given a width of 40 characters.
	scroller = new JScrollPane();
	editor = new JTextArea ();
	editor.setColumns(40);
        editorPanel.add(scroller, BorderLayout.CENTER);
	scroller.getViewport().add(editor);
        
        //Now assemble the components
	topPanel.add(leftButtonPanel, BorderLayout.WEST);
	topPanel.add(rightButtonPanel, BorderLayout.EAST);
	topPanel.add(editorPanel, BorderLayout.CENTER);
        
	//Configure the top-level JFrame
	setTitle("Model Editor");
	getContentPane().add(topPanel, BorderLayout.CENTER);
	addWindowListener(new java.awt.event.WindowAdapter() {
	  public void windowClosing(WindowEvent e) {
		e.getWindow().setVisible(false);
	  }
	});

        alert = new MessageBox(this, "alert", "Please upload model file or create model file first...", 300);
	pack();
        setLocation(10,10);
	setVisible(true);
  }
  
  //The following methods implement the button click behaviour.
  //Display a file dialog and load a file.
  private void loadFile() {
	JFileChooser fc = new JFileChooser();
	int returnVal = fc.showOpenDialog(this);
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	  //If a file was selected, try and load it.
	  File file = fc.getSelectedFile();
	  try {
		editor.read(new FileReader(file), null);
	  }
	  catch (IOException exp) {}
          filePath = file.getAbsolutePath();
          fileDir = file.getParent();
	  MainWindow.tArea.append("Model file loaded from:   " + fileDir + "\n");
	}
  }
  //Display a save file dialog and save the current file.
  private void saveFile() {
	JFileChooser fc = new JFileChooser ();
	int returnVal = fc.showSaveDialog(this);
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	  File file = fc.getSelectedFile();
	  //openedFile = file;
	  try {
		editor.write(new FileWriter(file));
	  }
	  catch (IOException exp) {}
          filePath = file.getAbsolutePath();
          fileDir = file.getParent();
	  MainWindow.tArea.append("Model file saved in:   " + fileDir + "\n");
	}
  }
  //Cut, copy and paste are implemented using methods provided by a
  //superclass of the JTextArea class, and work with the system
  //clipboard. Very useful and makes it very easy to implement
  //cut/copy/paste!!
  //
  //The requestFocus method is used to make the JTextArea the active
  //component after a button is clicked. The component with the focus
  //receives the input events. If focus is not returned to the
  //JTextArea it remains with the button, preventing text being
  //entered into the text area until it is clicked on to regain
  //focus.
  private void copy() {
	editor.copy();
	editor.requestFocus();
  }
  private void paste() {
	editor.paste();
	editor.requestFocus();
  }
  private void cut() {
	editor.cut();
	editor.requestFocus();
  }
  
  private void runScript() {
        if (filePath == null)
        {
            alert.setVisible(true);
            return;
        }
        try
        {
            File theFile = new File("runScript.exe");
            BufferedWriter fileWriter = new BufferedWriter(new FileWriter(theFile));
            fileWriter.write("#!/bin/sh\n");
            //fileWriter.write("cd ../../\n");
            fileWriter.write("ls\n");
            fileWriter.flush();
            fileWriter.close();
        }
        catch (IOException ioe)
        {
           MainWindow.tArea.append("Cannot write the file due to error " + ioe.toString());
        }
        String theCmd0 = "chmod 777 runScript.exe";
        String theCmd = "./runScript.exe";
        MainWindow.tArea.append(theCmd + "\n");
        try
        {
            Process theProcess0 = Runtime.getRuntime().exec(theCmd0);
            theProcess0.waitFor();
            Process theProcess = Runtime.getRuntime().exec(theCmd);
            theProcess.waitFor();
            InputStream in = theProcess.getInputStream();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] buffer = new byte[8192];
            int bytesRead = 0;
            while ((bytesRead = in.read(buffer, 0, 8192)) != -1) 
                baos.write(buffer, 0, bytesRead);
            String data = new String(baos.toByteArray());
            MainWindow.tArea.append(data);
        }
        catch (IOException ioe)
        {
            MainWindow.tArea.append("an I/O error occurs" + ioe.toString());
        }
        catch(InterruptedException e) 
        {
            MainWindow.tArea.append("Interrupted waiting for process!");
        }
  }


  	private void codeGenerate() {
        if (filePath == null)
        {
            alert.setVisible(true);
            return;
        }
	 
	try
        {
            File theFile = new File("codeGenerate.exe");
            BufferedWriter fileWriter = new BufferedWriter(new FileWriter(theFile));
            fileWriter.write("#!/bin/sh\n");
            fileWriter.write("cd " + fileDir + "\n");
            fileWriter.write("bmac " + filePath + "\n");
            fileWriter.flush();
            fileWriter.close();
        }
        catch (IOException ioe)
        {
           MainWindow.tArea.append("Cannot write the file due to error " + ioe.toString());
        }
        String theCmd0 = "chmod 777 codeGenerate.exe";
        String theCmd = "./codeGenerate.exe";
         

       try
        {
		//MainWindow.tArea.append("start generating...\n");
            Process theProcess0 = Runtime.getRuntime().exec(theCmd0);
            theProcess0.waitFor();
            Process theProcess = Runtime.getRuntime().exec(theCmd);
            //theProcess.waitFor();
            InputStream in = theProcess.getInputStream();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] buffer = new byte[8192];
            int bytesRead = 0;
            while ((bytesRead = in.read(buffer, 0, 8192)) != -1) 
                baos.write(buffer, 0, bytesRead);
            String data = new String(baos.toByteArray());
            MainWindow.tArea.append(data);
		MainWindow.tArea.append("C code generated!\n");
        }
        catch (IOException ioe)
        {
            MainWindow.tArea.append("an I/O error occurs" + ioe.toString());
        }
        catch(InterruptedException e) 
        {
            MainWindow.tArea.append("Interrupted waiting for process!");
        }
  }
 
 

private void install() {
        if (filePath == null)
        {
            alert.setVisible(true);
            return;
        }

	  try
        {
            File theFile = new File("install.exe");
            BufferedWriter fileWriter = new BufferedWriter(new FileWriter(theFile));
            fileWriter.write("#!/bin/sh\n");
            fileWriter.write("cd " + fileDir + "\n");
            fileWriter.write("./install.spice3f5\n");
            fileWriter.flush();
            fileWriter.close();
        }
        catch (IOException ioe)
        {
           MainWindow.tArea.append("Cannot write the file due to error " + ioe.toString());
        }
        String theCmd0 = "chmod 777 install.exe";
        String theCmd = "./install.exe";
       
	  try
        {
	    //MainWindow.tArea.append("start installing...\n");
	   Process theProcess0 = Runtime.getRuntime().exec(theCmd0);
            theProcess0.waitFor();
            Process theProcess = Runtime.getRuntime().exec(theCmd);
            //theProcess.waitFor();
            InputStream in = theProcess.getInputStream();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] buffer = new byte[8192];
            int bytesRead = 0;
            while ((bytesRead = in.read(buffer, 0, 8192)) != -1) 
                baos.write(buffer, 0, bytesRead);
            String data = new String(baos.toByteArray());
            MainWindow.tArea.append(data);
	    MainWindow.tArea.append("C code installed!\n");
        }
        catch (IOException ioe)
        {
            MainWindow.tArea.append("an I/O error occurs" + ioe.toString());
        }
        catch(InterruptedException e) 
        {
            MainWindow.tArea.append("Interrupted waiting for process!");
        }
  }

  public static void main(final String[] args) {
	final FullyFunctionalEditor editor = new FullyFunctionalEditor ();
  }
}
