----------------------------------------------------
-- Thermal Resistor Equivelant
-- 
-- Author: Allan Ecker
-- Created: July 23, 2003
--
-------------------------------------------------------------------------------
-- Description:
-- Model the relation between heat flow, temperature and thermal 
-- properties of a material as a a resistive element
-------------------------------------------------------------------------------

package thermal_system is
        nature thermal is real across real through;
        terminal thermal_ground : thermal;
end thermal_system;
        
use thermal_system.all;
                                 
                                  

                                                   
entity thR is
	generic ( 
                R : real := 1.0e1   --Degrees Kelvin per Watt
	);
	port ( 
		terminal t1, t2 : thermal
	);
end thR;


architecture arch1 of thR is
	quantity temp across HeatProduced through t1 to t2;
begin
  Thermal_equations: procedural is
  begin -- procedural statements                              
        HeatProduced := temp/R; --Equivelant to a resistor
  end procedural;
end architecture arch1;
