package electrical_system is
	nature electrical is real across real through;
	terminal ground : electrical;
end electrical_system;

use electrical_system.all;

entity mymos1 is
	generic ( belta : real := 1.0;	-- belta
		  vthres: real :=0.5);	-- threshold voltage
	port ( terminal drn, gat, src : electrical );
end mymos1;

architecture arch1 of mymos1 is
	quantity vgs across gat to src;
	quantity vds across drn to src;
	quantity ids through drn to src;
begin
  MOSequations: procedural is
	variable idstmp : real;
  begin -- procedural statements

	IF vds > 0 THEN			-- forward
	   IF vgs <= vthres THEN	-- cut off
		idstmp := 0.0;
	   ELSE
		IF vgs-vthres <= vds THEN	-- saturation
		   idstmp := belta * (((vgs - vthres)**2.0) / 2.0);
	   	ELSE					-- triode
		   idstmp := belta * ((vgs - vthres)*vds - ((vds**2.0)/2.0));
		END IF;
	   END IF;
	ELSE idstmp := 0.0;
	END IF;
	ids1 := idstmp;
	ids := ids1;
  end procedural;
end architecture arch1;
