.LIB soifet3
*NMOS parameters extracted from data from soifet3 w3 row4,col2, the same data
*sent to Pin Su at UC Berkeley for development of the improved FDSOI model.
*This parameter set is for the BULK bsim3v3.2 model, with parameters K1 and
*K2 adjusted to properly represent the effect of HANDLE WAFER voltage, not 
*body voltage.  It includes measured values of gate overlap capacitance and
*"juction" capacitance (i.e. source and drain to handle wafer) in inversion 
*or accumulation.  This probably grossly overstates the true CJ, which has
*to be determined by high frequency data fitting.  At worst, CJ for the 
*NeoCAD runs will be half the value given, since the buried oxide will be
*twice as thick.  (See ~utmost_data/mos/s3w3/v32.l)
* DATE: Dec 20/01                                                               
* LOT: soifet3               WAF: 3                                             
* DIE: r4c2                  DEV: 0.4/0.2d                                      
* Temp= 22                                                                      
.MODEL AllWandL nmos (                            LEVEL   = 81                 
+VERSION = 3.2            TNOM    = 22             TOX     = 4.2E-9             
+XJ      = 1E-7           NCH     = 6E17           NSUB    = 3E15               
+VTH0    = 0.47           K1      = 0.01           K2      = 0.015              
+K3      = 6              K3B     = 0              W0      = 0                  
+NLX     = 0              DVT0W   = 0              DVT1W   = 2E6                
+DVT2W   = 0.1            DVT0    = 1.5            DVT1    = 0.35               
+DVT2    = 0.12           U0      = 0.041          UA      = 0                  
+UB      = 1.2E-18        UC      = 0              VSAT    = 8E4                
+A0      = 0              AGS     = 0              B0      = 0                  
+B1      = 0              KETA    = 0              A1      = 0                  
+A2      = 0.99           RDSW    = 340            PRWG    = 0                  
+PRWB    = 0              WR      = 1              WINT    = 5E-8               
+LINT    = 2.7E-8         DWG     = -9E-8          DWB     = 0                  
+VOFF    = -0.13          NFACTOR = 0.5            CIT     = 0                  
+CDSC    = 1E-3           CDSCD   = 0              CDSCB   = -5E-4              
+ETA0    = 0.9            ETAB    = 0              DSUB    = 1                  
+PCLM    = 1.5            PDIBLC1 = 0              PDIBLC2 = 0                  
+PDIBLCB = 0              DROUT   = 0.3            PSCBE1  = 1E8                
+PSCBE2  = 0              PVAG    = 0.5            DELTA   = 0.01               
+NGATE   = 1E20           ALPHA0  = 1E-8           ALPHA1  = 0.1                
+BETA0   = 22             PB      = 10             JS      = 0                  
+JSW     = 0              MOBMOD  = 1              PRT     = 0                  
+UTE     = -0.45          KT1     = -0.06          KT1L    = 0                  
+KT2     = 0              UA1     = 0              UB1     = 0                  
+UC1     = 0              AT      = 2E5            CAPMOD  = 2                  
+NQSMOD  = 0              ELM     = 5              XPART   = 0                  
+WL      = 0              WLN     = 1.11           WW      = 0                  
+WWN     = 1.5            WWL     = -3E-25         LL      = 0                  
+LLN     = 1              LW      = 3E-18          LWN     = 1.5                
+LWL     = 0              CGSL    = 0              CGDL    = 0                  
+CKAPPA  = 0.6            CF      = 0              CLC     = 1E-7               
+CLE     = 0.6            DWC     = -7.5E-8        CGDO    = 4E-10              
+CGSO    = 4E-10          CGBO    = 0              CJ      = 1.7E-4             
+MJ      = 0.5            CJSW    = 0              BINUNIT = 1                  
+IS      = 0              INTCAP  = 1              BERK    = -3              )  
*
*This pmos model is estimated based on extrapolation plus limited data from
*soifet3 wafer1.  It crudely fits median on and off current from that wafer.
.MODEL EstimatedPmos pmos (                        LEVEL   = 8                  
+VERSION = 3.2            TNOM    = 22             TOX     = 4.2E-9             
+XJ      = 1E-7           NCH     = 6E17           NSUB    = 3E15               
+VTH0    = -0.4           K1      = 0.01           K2      = 0.015              
+K3      = 1              K3B     = 0              W0      = 0                  
+NLX     = 0              DVT0W   = 0              DVT1W   = 0                  
+DVT2W   = 0              DVT0    = 6              DVT1    = 0.5                
+DVT2    = 0.1            U0      = 5E-3           UA      = 0                  
+UB      = 0              UC      = 0              VSAT    = 8E4                
+A0      = -10            AGS     = 0              B0      = 0                  
+B1      = 0              KETA    = 0              A1      = 0                  
+A2      = 0.4            RDSW    = 550            PRWG    = 0                  
+PRWB    = 0              WR      = 1              WINT    = 0                  
+LINT    = 0              DWG     = 0              DWB     = 0                  
+VOFF    = -0.1           NFACTOR = 0              CIT     = 0                  
+CDSC    = 0              CDSCD   = 0              CDSCB   = 0                  
+ETA0    = 0.03           ETAB    = 0              DSUB    = 0.5                
+PCLM    = 3              PDIBLC1 = 0.3            PDIBLC2 = 0                  
+PDIBLCB = 0              DROUT   = 0.25           PSCBE1  = 6E8                
+PSCBE2  = 1E-10          PVAG    = 0              DELTA   = 0.01               
+NGATE   = 8E19           ALPHA0  = 1E-9           ALPHA1  = 0                  
+BETA0   = 22             PB      = 10                      
+JS      = 0              JSW     = 0              MOBMOD  = 1                  
+PRT     = 0              UTE     = -0.55          KT1     = -0.1               
+KT1L    = 0              KT2     = 0              UA1     = 0                  
+UB1     = 0              UC1     = 0              AT      = 3E5                
+CAPMOD  = 2              VFBCV   = 1              NQSMOD  = 0                  
+ELM     = 5              XPART   = 0              WL      = 0                  
+WLN     = 1              WW      = 0              WWN     = 1                  
+WWL     = 0              LL      = 0              LLN     = 1                  
+LW      = 0              LWN     = 1              LWL     = 0                  
+CGSL    = 0              CGDL    = 0              CKAPPA  = 0.6                
+CF      = 0              CLC     = 1E-7           CLE     = 0.6                
+DWC     = -7.5E-8        CGDO    = 4E-10          CGSO    = 4E-10              
+CGBO    = 0              CJ      = 1.7E-4         MJ      = 0.5                
+CJSW    = 0              CJSWG   = 0              MJSWG   = 0                  
+BINUNIT = 1              IS      = 0              INTCAP  = 1                  
+BERK    = -3             N       = 1               )                           
*                                                                               
.ENDL soifet3                                                                   